VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Bezier curve generator"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   495
      Left            =   120
      ScaleHeight     =   435
      ScaleWidth      =   1155
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub Form_Activate()

    Picture1.ForeColor = vbWhite
    Picture1.Print _
            "to see the bezier curve," & vbCrLf & _
            "drag & drop from the upper-left corner" & vbCrLf & _
            "of this window 4 times"

End Sub
Private Sub Form_Load()

    Picture1.AutoRedraw = True
    Picture1.BackColor = vbBlack

    Picture1.ScaleMode = 3 'for PolyBezier api

End Sub
Private Sub Form_Resize()

    Picture1.Move 0, 0, Form1.ScaleWidth, Form1.ScaleHeight

End Sub
Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim i As Integer
    Dim CurrentDistance As Single
    Dim BestDistance As Single
    Dim BestIndex As Integer

'on drag
    If Button <> 0 Then

'move nearest control point
        For i = 0 To 3
            CurrentDistance = _
                    ((X - P(i).X) ^ 2 + (Y - P(i).Y) ^ 2) ^ (1 / 2)
            If i = 0 Or CurrentDistance < BestDistance Then
                BestDistance = CurrentDistance
                BestIndex = i
            End If
        Next i
        P(BestIndex).X = X
        P(BestIndex).Y = Y

'clear canvas
        Picture1.Cls

'draw bezier curve with custom function
        Picture1.ForeColor = vbYellow
        Picture1.DrawStyle = 0 'solid line
        Call DrawBezierCurve(Picture1, P, 10)

'draw bezier curve with Windows API
        Picture1.ForeColor = vbRed
        Picture1.DrawStyle = 2 'dotted line
        Call PolyBezier(Picture1.hdc, P(0), 4)

'draw control vectors
        Picture1.ForeColor = vbGreen
        Picture1.DrawStyle = 2 'dotted line
        Picture1.CurrentX = P(0).X
        Picture1.CurrentY = P(0).Y
        For i = 0 To 3
            Picture1.Line _
                    ( _
                    Picture1.CurrentX, _
                    Picture1.CurrentY _
                    )- _
                    ( _
                    P(i).X, _
                    P(i).Y _
                    )
        Next i

'draw control points
        Picture1.ForeColor = vbRed
        For i = 0 To 3
            Picture1.CurrentX = P(i).X
            Picture1.CurrentY = P(i).Y
            Picture1.PSet (P(i).X, P(i).Y)
            Picture1.Print i + 1
        Next i

    End If

End Sub
