Attribute VB_Name = "Module1"
'Program: Bezier curve generator
'Purpose: demonstration
'Author: Jerry J. Chen
'E-Mail: onlyuser@hotmail.com
'Homepage: members.xoom.com/onlyuser
'References: 3D Computer Graphics by Alan Watt
'Comments: hope you find this interesting

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Declare Function PolyBezier Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, ByVal cPoints As Long) As Long

Public P(0 To 3) As POINTAPI
'draws a single Bezier curve segment with 4 control points
Function DrawBezierCurve(Canvas As PictureBox, P() As POINTAPI, Steps As Integer)

    Dim i As Integer
    Dim j As Integer
    Dim u As Single
    Dim B(0 To 3) As Single
    Dim Q() As POINTAPI
    
    'calculate Bezier curve
    ReDim Q(0 To Steps)
    For i = 0 To Steps
    
        u = i / Steps
        
        'Bernstein cubic polynomials
        B(0) = (1 - u) ^ 3
        B(1) = 3 * u * (1 - u) ^ 2
        B(2) = 3 * u ^ 2 * (1 - u)
        B(3) = u ^ 3
        
        For j = 0 To 3
            Q(i).X = Q(i).X + P(j).X * B(j)
            Q(i).Y = Q(i).Y + P(j).Y * B(j)
        Next j
        
    Next i
    
    'draw Bezier curve
    Canvas.CurrentX = Q(0).X
    Canvas.CurrentY = Q(0).Y
    For i = 0 To Steps
        Canvas.Line _
            ( _
                Canvas.CurrentX, _
                Canvas.CurrentY _
            )- _
            ( _
                Q(i).X, _
                Q(i).Y _
            )
    Next i
    
End Function
